// C Source File
// Created 8/18/2001; 9:16:02 PM
//if chosen lines
#include "declarations.h"
enum {STD = 1, MXB};
void linehand (short result)
{
	short stringlength, top, bottom, width, extrawidth = 0;
	HANDLE dialoghandle = H_NULL;
	char rawvalues[80] = {};
	char* x1value, *x2value, *y1value, *y2value, *avalue, *bvalue, *cvalue;
	ESI ptr, exact, approx;
	short lcd_width = LCD_WIDTH, ti92plus = (TI92PLUS || V200);
	WinClr (DeskTop);
	FontSetSys (F_6x8);
	if (ti92plus)
	{
		extrawidth = 10;
	}
	if (result != CONVERT)
	{
		stringlength = DrawStrWidth ("(x1,y1), (x2,y2)", F_6x8);
		DrawStr ((lcd_width - stringlength)/2, 20, "(x1,y1), (x2,y2)", A_REPLACE);
		dialoghandle = DialogNewSimple (155 + 2 * extrawidth, 47 + extrawidth);
		DialogAddTitle (dialoghandle, "Enter values", BT_OK, BT_CANCEL);
		DialogAddRequest (dialoghandle, 3, 14, "x1=", 0, 19, 8);
		DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus, "y1=", 20, 19, 8);
		DialogAddRequest (dialoghandle, 70 + extrawidth, 14, "x2=", 40, 19, 8);
		DialogAddRequest (dialoghandle, 70 + extrawidth, 24 + 2 * ti92plus, "y2=",
			60, 19, 8);
	}
	switch (result)
	{
	case (SLOPE):
		if (DialogDo (dialoghandle, CENTER, 30 + 2 * ti92plus, rawvalues, NULL)
			== KEY_ENTER)
		{
			x1value = rawvalues;
			y1value = rawvalues + 20;
			x2value = rawvalues + 40;
			y2value = rawvalues + 60;
			HeapFree (dialoghandle);
  		dialoghandle = H_NULL;

			//push_END_TAG();//end, y2, y1, -, x2, x1, -, div
			push_parse_text (y2value);
			push_parse_text (y1value);
			push_quantum (SUB_TAG);
			push_parse_text (x2value);
			push_parse_text (x1value);
			push_quantum_pair (SUB_TAG, DIV_TAG);

			ptr = top_estack;
			NG_rationalESI (top_estack);
			exact = top_estack;
			NG_approxESI (ptr);
			approx = top_estack;

			WinClr (DeskTop);

			Parms2D (Parse2DExpr (exact, 1), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

			ngetchx();
			WinClr (DeskTop);

			Parms2D (Parse2DExpr (approx, 1), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

			ST_helpMsg ("Store ans to history? Enter=Yes");
	  	if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	case (DIST):
		if (DialogDo (dialoghandle, CENTER, 30 + 2 * ti92plus, rawvalues, NULL)
			== KEY_ENTER)
		{
			x1value = rawvalues;
			y1value = rawvalues + 20;
			x2value = rawvalues + 40;
			y2value = rawvalues + 60;
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;

			//push_END_TAG();//2, x1, x2, -, ^, 2, y1, y2, -, ^, +, SQRT
			push_longint (2);
			push_parse_text (x1value);
			push_parse_text (x2value);
			push_quantum_pair (SUB_TAG, POW_TAG);
			push_longint (2);
			push_parse_text (y1value);
			push_parse_text (y2value);
			push_quantum_pair (SUB_TAG, POW_TAG);
			push_quantum_pair (ADD_TAG, SQRT_TAG);

			ptr = top_estack;//save position for later, so don't have to repush all
			NG_rationalESI (ptr);
			exact = top_estack;
			NG_approxESI (ptr);
			approx = top_estack;

			WinClr (DeskTop);

			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

			ngetchx();
			WinClr (DeskTop);

			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	case (MID):
		if (DialogDo (dialoghandle, CENTER, 30 + 2 * ti92plus, rawvalues, NULL)
			== KEY_ENTER)
		{
			x1value = rawvalues;
			y1value = rawvalues + 20;
			x2value = rawvalues + 40;
			y2value = rawvalues + 60;
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;

			//push_END_TAG();//end, x1, x2, +, 2, div, x, =
			push_parse_text (y1value);
			push_parse_text (y2value);
			push_quantum (ADD_TAG);
			push_longint ((long)2);
			push_quantum_pair (DIV_TAG, VAR_Y_TAG);
			push_quantum (EQ_TAG);

			push_parse_text (x1value);
			push_parse_text (x2value);
			push_quantum (ADD_TAG);
			push_longint ((long)2);
			push_quantum_pair (DIV_TAG, VAR_X_TAG);
			push_quantum_pair (EQ_TAG, LIST_TAG);

			ptr = top_estack;
			NG_rationalESI (ptr);
			exact = top_estack;
			NG_approxESI (ptr);
			approx = top_estack;

			WinClr (DeskTop);

			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

			ngetchx();
			WinClr (DeskTop);

			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	case (CONVERT):
		push_quantum (VAR_C_TAG);
		push_quantum_pair (VAR_A_TAG, VAR_X_TAG);
		push_quantum_pair (MUL_TAG, VAR_B_TAG);
		push_quantum_pair (VAR_Y_TAG, MUL_TAG);
		push_quantum_pair (ADD_TAG, EQ_TAG);
		NG_rationalESI (top_estack);

		Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
		Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 20 + top);
		dialoghandle = DialogNewSimple (140 + 2 * extrawidth, 54 + extrawidth);
		DialogAddRequest (dialoghandle, 1, 14, "a=", 0, 19, 8);
		DialogAddRequest (dialoghandle, 1, 24 + 2 * ti92plus, "b=", 20, 39, 8);
		DialogAddRequest (dialoghandle, 1, 34 + 4 * ti92plus, "c=", 40, 59, 8);
		DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
		if (DialogDo (dialoghandle, CENTER, 23 + top + bottom, rawvalues, NULL) ==
			KEY_ENTER)
		{
			avalue = rawvalues;
			bvalue = rawvalues + 20;
			cvalue = rawvalues + 40;
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;

			//push_END_TAG();
			push_quantum (VAR_Y_TAG);
			push_parse_text (cvalue);
			push_parse_text (avalue);
			push_quantum_pair (VAR_X_TAG, MUL_TAG);
			push_parse_text (bvalue);
			push_quantum_pair (VAR_Y_TAG, MUL_TAG);
			push_quantum_pair (ADD_TAG, EQ_TAG);
			push_quantum (SOLVE_TAG);

			ptr = top_estack;
			NG_rationalESI (ptr);
			exact = top_estack;
			NG_approxESI (ptr);
			approx = top_estack;

			WinClr (DeskTop);

			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

			ngetchx();
			WinClr (DeskTop);

			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  				saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	case (EQUATION):
		if (DialogDo (dialoghandle, CENTER, 30 + 2 * ti92plus, rawvalues, NULL)
			== KEY_ENTER)
		{
			x1value = rawvalues;
			y1value = rawvalues + 20;
			x2value = rawvalues + 40;
			y2value = rawvalues + 60;
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;

			/*push_END_TAG();//end, (y2, y1, -, x2, x1, -, /, m, =), (y1, y, =), and,
			push_parse_text (y2value);
			push_parse_text (y1value);
			push_quantum (SUB_TAG);
			push_parse_text (x2value);
			push_parse_text (x1value);
			push_quantum_pair (SUB_TAG, DIV_TAG);
			push_quantum_pair (VAR_M_TAG, EQ_TAG);//m = (y2 - y1) / (x2 - x1)
			push_parse_text (y1value);
			push_quantum_pair (VAR_Y_TAG, EQ_TAG);//y = y1value
			push_quantum (AND_TAG);
			push_parse_text (x1value);
			push_quantum_pair (VAR_X_TAG, EQ_TAG);//x = x1value
			push_quantum_pair (AND_TAG, VAR_B_TAG);
			push_quantum_pair (VAR_Y_TAG, VAR_M_TAG);
			push_quantum_pair (VAR_X_TAG, MUL_TAG);
			push_quantum_pair (VAR_B_TAG, ADD_TAG);
			push_quantum_pair (EQ_TAG, SOLVE_TAG);
			push_quantum (WITH_TAG);//solve (y = m*x+b,b)|y=y1value, m=slope,x=x1value

			NG_rationalESI (top_estack);//y2, y1, -, x2, x1, -, /, m, =, and, m, x,

			push_parse_text (y2value);
			push_parse_text (y1value);
			push_quantum (SUB_TAG);
			push_parse_text (x2value);
			push_parse_text (x1value);
			push_quantum_pair (SUB_TAG, DIV_TAG);
			push_quantum_pair (VAR_M_TAG, EQ_TAG);
			push_quantum_pair (AND_TAG, VAR_M_TAG);
			push_quantum_pair (VAR_X_TAG, MUL_TAG);
			push_quantum_pair (VAR_B_TAG, ADD_TAG);
			push_quantum_pair (VAR_Y_TAG, EQ_TAG);
			push_quantum (WITH_TAG);*/
			//y=mx+b, or
			//y = (y2 - y1) / (x2 - x1) * x + (y1 - (y2 - y1) / (x2 - x1) * x1)

			push_parse_text (y2value);
			push_parse_text (y1value);
			push_quantum (SUB_TAG);
			push_parse_text (x2value);
			push_parse_text (x1value);
			push_quantum_pair (SUB_TAG, DIV_TAG);
			push_quantum_pair (VAR_X_TAG, MUL_TAG);
			push_parse_text (y1value);
			push_parse_text (y2value);
			push_parse_text (y1value);
			push_quantum (SUB_TAG);
			push_parse_text (x2value);
			push_parse_text (x1value);
			push_quantum_pair (SUB_TAG, DIV_TAG);
			push_parse_text (x1value);
			push_quantum (MUL_TAG);
			push_quantum_pair (SUB_TAG, ADD_TAG);
			push_quantum_pair (VAR_Y_TAG, EQ_TAG);

			ptr = top_estack;
			NG_rationalESI (ptr);
			exact = top_estack;
			NG_approxESI (ptr);
			approx = top_estack;

			WinClr (DeskTop);

			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

			ngetchx();
			WinClr (DeskTop);

			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack,DeskTop,(lcd_width - width)/2, 18 + top);
			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	}
	if (dialoghandle)
	{
		HeapFree (dialoghandle);
		dialoghandle = H_NULL;
	}
}
