// C Source File
// Created 8/15/2001; 10:53:18 PM
//to handle results if it is in the parabola section
#include "declarations.h"

void push_discrim (char* avalue, char* bvalue, char* cvalue);
void parabhand (short result, LCD_BUFFER buffer)//to handle if result is for
{//parabolas
	short width, bottom, top, size, size2, extrawidth;
	ESI ptr, modenamea, modenameb, quadpos, quadneg, exact, approx;
	HANDLE dialoghandle = H_NULL;
	unsigned char rpnnotation[100] = {END_TAG,//end, a, 2, x, ^, *, b, x, *, c,
		VAR_A_TAG, 2, 1, POSINT_TAG, VAR_X_TAG, POW_TAG, MUL_TAG,//+, +
		VAR_B_TAG, VAR_X_TAG, MUL_TAG, VAR_C_TAG, ADD_TAG, ADD_TAG};
	char rawvalue[60] = {};
	char* avalue, *bvalue, *cvalue;
	char* currentmode;
	char* dispmode;
	short lcd_width = LCD_WIDTH, ti92plus = (TI92PLUS || V200);
	BOOL too_big = FALSE;

	LCD_restore (buffer);//restore the background
	WinClr (DeskTop);//clear the background
	if (TI89)
	{
		extrawidth = 0;
	}
	else
	{
		extrawidth = 10;
	}
	dialoghandle = DialogNewSimple (125 + 4 * extrawidth, 54 + extrawidth);

	NG_rationalESI (rpnnotation + 13);//evaluate the expression at rpnnotation
	Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom, &top);
	Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 20 + top);
	size = top + bottom;

	DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  DialogAddRequest (dialoghandle, 3, 14, "a=", 0, 19, 8);
  DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus, "b=", 20, 19, 8);
  DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "c=", 40, 19, 8);
	switch (result)
	{
	case (X_ICEPT):
		if (DialogDo (dialoghandle, CENTER, 25 + size, rawvalue, NULL) ==
  		KEY_ENTER)
  	{
  		avalue = rawvalue;
  		bvalue = rawvalue+20;
  		cvalue = rawvalue+40;
  		HeapFree (dialoghandle);
  		dialoghandle = H_NULL;
  		push_string ($(RECTANGULAR));//push modesettingstring
  		modenameb = top_estack;//save that position
			push_whole_string ("Complex Format");//push modenamestring
			modenamea = top_estack;//save position
			push_setmode (modenamea, modenameb);//set mode
			ptr = top_estack;//save top of estack
			currentmode = (char*)GetStrnArg (ptr);//get the name of current mode
			push_whole_string ("Display Digits");
			modenamea = top_estack;
			push_whole_string ("FLOAT 12");
			modenameb = top_estack;
			push_setmode (modenamea, modenameb);
			ptr = top_estack;
			dispmode = (char*)GetStrnArg (ptr);

			ptr = top_estack;
			//push_END_TAG();//end, discrim, sqrt_tag
			push_parse_text (bvalue);
			push_quantum (MINUS_TAG);
  		push_discrim (avalue, bvalue, cvalue);
  		push_quantum_pair (SQRT_TAG, ADD_TAG);
  		push_longint ((long)2);
  		push_parse_text (avalue);
  		push_quantum_pair (MUL_TAG, DIV_TAG);
  		push_quantum_pair (VAR_X_TAG, EQ_TAG);
  		quadpos = top_estack;

			//push_END_TAG();//end, discrim, sqrt_tag
			push_parse_text (bvalue);
			push_quantum (MINUS_TAG);
  		push_discrim (avalue, bvalue, cvalue);
  		push_quantum_pair (SQRT_TAG, SUB_TAG);
  		push_longint ((long)2);
  		push_parse_text (avalue);
  		push_quantum_pair (MUL_TAG, DIV_TAG);
  		push_quantum_pair (VAR_X_TAG, EQ_TAG);
  		quadneg = top_estack;

  		push_END_TAG();
			NG_rationalESI (quadneg);
			NG_rationalESI (quadpos);
			push_LIST_TAG();
			exact = top_estack;
			size = exact - quadneg;

			WinClr (DeskTop);

			Parms2D (Parse2DExpr (top_estack, FALSE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				too_big = TRUE;
			}
			else
				Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, top + 18);
			ngetchx();//end, -b, discrim, SQRT_T

			ptr = top_estack;
			push_END_TAG();
			NG_approxESI (quadpos);
			NG_approxESI (quadneg);
			push_LIST_TAG();
			approx = top_estack;
			size2 = approx - ptr;

			if (too_big)
				goto save_icept;

			Parms2D ((ptr = Parse2DExpr (exact, TRUE)), &width, &bottom,	&top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				goto save_icept;
			}

			WinClr (DeskTop);
			Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, top + 18);

		 	ST_helpMsg ("Put in history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
save_icept:
  			saveResult (exact, size, approx, size2);

			push_whole_string ("Complex Format");
  		modenamea = top_estack;
  		push_ANSI_string (currentmode);
  		modenameb = top_estack;
  		push_setmode (modenamea, modenameb);
  		push_whole_string ("Display Digits");
  		modenamea = top_estack;
  		push_whole_string (dispmode);
  		modenameb = top_estack;
  		push_setmode (modenamea, modenameb);
  	}
  	else
  	{
  		HeapFree (dialoghandle);
  		dialoghandle = H_NULL;
  	}
		break;
	case (VERTEX):
		if (DialogDo (dialoghandle, CENTER, 25 + size, rawvalue, NULL) == KEY_ENTER)
		{
  		avalue = rawvalue;
  		bvalue = rawvalue+20;
  		cvalue = rawvalue+40;
  		HeapFree (dialoghandle);
  		dialoghandle = H_NULL;
  		
  		push_END_TAG();
 			push_parse_text (bvalue);
			push_quantum (MINUS_TAG);
			push_longint ((long)2);
			push_parse_text (avalue);
			push_quantum_pair (MUL_TAG, DIV_TAG);
			push_quantum_pair (VAR_X_TAG, EQ_TAG);

			ptr = top_estack;//x, -b, 2, a, *, /, =, a, x, 2, ^, *, b, x, *, +, c,

			push_parse_text (avalue);
			push_longint ((long)2);
			push_quantum_pair (VAR_X_TAG, POW_TAG);
			push_quantum (MUL_TAG);
			push_parse_text (bvalue);
			push_quantum_pair (VAR_X_TAG, MUL_TAG);
			push_quantum (ADD_TAG);
			push_parse_text (cvalue);
			push_quantum_pair (ADD_TAG, WITH_TAG);
			push_quantum_pair (VAR_Y_TAG, EQ_TAG);

			quadneg = top_estack;//just reusing variables

			push_END_TAG();
			NG_rationalESI (quadneg);
			NG_rationalESI (ptr);
			push_LIST_TAG();
			exact = top_estack;
			size = exact - quadneg;

			WinClr (DeskTop);
			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				too_big = TRUE;
			}
			else
				Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, top + 18);

			ngetchx();

			modenamea = top_estack;
			push_END_TAG();
			NG_approxESI (quadneg);
			NG_approxESI (ptr);
			push_LIST_TAG();
			approx = top_estack;

			if (too_big)
				goto store_vertex;

			WinClr (DeskTop);
			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				goto store_vertex;
			}

			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, top + 18);

			ST_helpMsg ("Put in history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
store_vertex:
  				saveResult (exact, size, approx, approx - modenamea);
  	}
  	else
  	{
  		HeapFree (dialoghandle);
  		dialoghandle = H_NULL;
  	}
		break;
	}
	if (dialoghandle)
	{
		HeapFree (dialoghandle);
		dialoghandle = H_NULL;
	}
}

void push_discrim (char* avalue, char* bvalue, char* cvalue)//to push the disc
{
	push_longint ((long)2);
	push_parse_text (bvalue);
	push_quantum (POW_TAG);
	push_longint ((long)4);
	push_parse_text (avalue);
	push_parse_text (cvalue);
	push_quantum_pair (MUL_TAG, MUL_TAG);
	push_quantum (SUB_TAG);
}
