// C Source File
// Created 4/11/2002; 9:33:09 PM
#include "declarations.h"
enum {TERM = 1, SUM = 2, INFSUM = 3, DIFF = 4, NTERMS = 5};
void serhand (short result)
{
	short lcd_width = LCD_WIDTH, ti92plus = (TI92PLUS || V200);
	HANDLE dialoghandle = H_NULL, popuphandle = H_NULL;
	short extrawid = 0, width, bottom, top;
	ESI ptr, exact, approx;
	char rawvalues [60], *term, *fterm, *dterm;

	popuphandle = PopupNew ("Which One?", 0);
	PopupAddText (popuphandle, -1, "Nth Term", TERM);
	PopupAddText (popuphandle, -1, "Number of terms", NTERMS);
	PopupAddText (popuphandle, -1, "Sum", SUM);
	WinClr (DeskTop);
	if (ti92plus)
	{
		extrawid = 10;
	}
	if (result == ARITHMETIC)
	{
		PopupAddText (popuphandle, -1, "Common Difference", DIFF);
		if (!(result = PopupDo (popuphandle, CENTER, CENTER, 0)))
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			return;
		}
		if (result == TERM)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  		DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
  		DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus,
  			"Difference", 20, 19, 8);
 			DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "Which Term", 40,
 				19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			//a1+d(n-1)
 			fterm = rawvalues;
 			dterm = rawvalues + 20;
 			term = rawvalues + 40;
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;

 			push_parse_text (term);
 			push_longint ((long)1);
 			push_quantum (SUB_TAG);
 			push_parse_text (dterm);
 			push_quantum (MUL_TAG);
 			push_parse_text (fterm);
 			push_quantum (ADD_TAG);

 			ptr = top_estack;
 			NG_rationalESI (ptr);
 			exact = top_estack;
 			NG_approxESI (ptr);
 			approx = top_estack;

 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

 			ngetchx();
 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

 			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else if (result == SUM)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  		DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
  		DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus,
  			"Last Term", 20, 19, 8);
 			DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "How many", 40,
 				19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			//n(n1+nn)/2=term(fterm + dterm)/2
 			fterm = rawvalues;
 			dterm = rawvalues + 20;
 			term = rawvalues + 40;
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;

 			push_parse_text (fterm);
 			push_parse_text (dterm);
 			push_quantum (ADD_TAG);
 			push_parse_text (term);
 			push_quantum (MUL_TAG);
 			push_longint ((long)2);
 			push_quantum (DIV_TAG);

 			ptr = top_estack;
 			NG_rationalESI (ptr);
 			exact = top_estack;
 			NG_approxESI (ptr);
 			approx = top_estack;

 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

 			ngetchx();
 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

 			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else if (result == DIFF)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  		DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
  		DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus,
  			"N'th Term", 20, 19, 8);
 			DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "N", 40,
 				19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			//d = (an - a1) / (n - 1)
 			fterm = rawvalues;//first
 			dterm = rawvalues + 20;//last
 			term = rawvalues + 40;//num
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;

 			push_parse_text (dterm);
			push_parse_text (fterm);
			push_quantum (SUB_TAG);
			push_parse_text (term);
			push_longint ((long)1);
			push_quantum_pair (SUB_TAG, DIV_TAG);

			ptr = top_estack;
 			NG_rationalESI (ptr);
 			exact = top_estack;
 			NG_approxESI (ptr);
 			approx = top_estack;

 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

 			ngetchx();
 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

 			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else if (result == NTERMS)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  		DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
  		DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus,
  			"Difference", 20, 19, 8);
 			DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "N'th Term", 40,
 				19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
			//n = (an - a1) / d + 1;
 			fterm = rawvalues;//first
 			dterm = rawvalues + 20;//diff
 			term = rawvalues + 40;//last
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;

 			push_parse_text (term);
			push_parse_text (fterm);
			push_quantum (SUB_TAG);
			push_parse_text (dterm);
			push_quantum (DIV_TAG);
			push_longint ((long)1);
			push_quantum (ADD_TAG);

			ptr = top_estack;
 			NG_rationalESI (ptr);
 			exact = top_estack;
 			NG_approxESI (ptr);
 			approx = top_estack;

 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

 			ngetchx();
 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);
 			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}

	}
	else if (result == GEOMETRIC)
	{
		PopupAddText (popuphandle, -1, "Infinite Sum", INFSUM);
		PopupAddText (popuphandle, -1, "Common Ratio", DIFF);
		if (!(result = PopupDo (popuphandle, CENTER, CENTER, 0)))
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			return;
		}
		if (result == SUM)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  		DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
  		DialogAddRequest (dialoghandle, 3, 24 + 2*ti92plus, "Ratio", 20, 19, 8);
 			DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "How Many", 40,
 				19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;
 			fterm = rawvalues;
 			dterm = rawvalues + 20;
 			term = rawvalues + 40;
 			//a1(1-r^n)/(1-r)=fterm(1-dterm^term)/(1-term)

 			push_longint ((long)1);
 			push_parse_text (term);
 			push_parse_text (dterm);
 			push_quantum_pair (POW_TAG, SUB_TAG);
 			push_parse_text (fterm);
 			push_quantum (MUL_TAG);
 			push_longint ((long)1);
 			push_parse_text (dterm);
 			push_quantum_pair (SUB_TAG, DIV_TAG);

 			ptr = top_estack;
 			NG_rationalESI (ptr);
 			exact = top_estack;
 			NG_approxESI (ptr);
 			approx = top_estack;

 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

 			ngetchx();
 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);
 			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else if (result == TERM)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  		DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
  		DialogAddRequest (dialoghandle, 3, 24 + 2*ti92plus,	"Ratio", 20, 19, 8);
 			DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "Which Term", 40,
 				19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			//a1*r^(n-1) = fterm*dterm^(term - 1)
 			fterm = rawvalues;
 			dterm = rawvalues + 20;
 			term = rawvalues + 40;
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;

 			push_parse_text (term);
 			push_longint ((long)1);
 			push_quantum (SUB_TAG);
 			push_parse_text (dterm);
 			push_quantum (POW_TAG);
 			push_parse_text (fterm);
 			push_quantum (MUL_TAG);

 			ptr = top_estack;
 			NG_rationalESI (ptr);
 			exact = top_estack;
 			NG_approxESI (ptr);
 			approx = top_estack;

 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

 			ngetchx();
 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

 			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else if (result == INFSUM)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
			DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
			DialogAddRequest (dialoghandle, 3, 24 + 2*ti92plus,	"Ratio", 20, 19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			//a1/(1-r)=fterm/(1-dterm)
 			fterm = rawvalues;
 			dterm = rawvalues + 20;
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;

 			push_parse_text (fterm);
 			push_longint ((long)1);
 			push_parse_text (dterm);
 			push_quantum_pair (SUB_TAG, DIV_TAG);

 			ptr = top_estack;
 			NG_rationalESI (ptr);
 			exact = top_estack;
 			NG_approxESI (ptr);
 			approx = top_estack;

 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

			ngetchx();
			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

 			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else if (result == DIFF)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
			DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
			DialogAddRequest (dialoghandle, 3, 24 + 2*ti92plus,	"N'th Term", 20, 19,
				8);
			DialogAddRequest (dialoghandle, 3, 34 + 4*ti92plus,	"N", 40, 19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			//an = a1*r^(n-1) This is a complicated transformation, showing it here
 			//an / a1 = r ^ (n - 1) so you get the idea of where it came from
 			//log (an / a1) = log (r ^ (n - 1))
 			//log (an / a1) = (n-1) log (r)
 			//log (an / a1) / (n - 1) = log (r)
 			//log ((an / a1) ^ (1 / (n - 1))) = log (r)
 			//(an / a1) ^ (1 / (n - 1)) = r
			fterm = rawvalues;//first: a1
			dterm = rawvalues + 20;//last: an
			term = rawvalues + 40;//num: n
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;

			push_longint ((long)1);
 			push_parse_text (term);
 			push_longint ((long)1);
 			push_quantum_pair (SUB_TAG, DIV_TAG);
 			push_parse_text (dterm);
 			push_parse_text (fterm);
 			push_quantum_pair (DIV_TAG, POW_TAG);

 			ptr = top_estack;
 			NG_rationalESI (ptr);
 			exact = top_estack;
 			NG_approxESI (ptr);
 			approx = top_estack;

 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

 			ngetchx();
 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

 			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else if (result == NTERMS)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
			DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
			DialogAddRequest (dialoghandle, 3, 24 + 2*ti92plus,	"N'th Term", 20, 19,
				8);
			DialogAddRequest (dialoghandle, 3, 34 + 4*ti92plus,	"Ratio", 40, 19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			//an = a1*r^(n-1) another somewhat complex transformation. Note: Due to
 			//an / a1 = r ^ (n - 1) the property of logs, the function "log" can be
 			//log (an / a1) = log (r ^ (n - 1)) in any base (but they have to be in
 			//log (an / a1) = (n-1) log (r) the same one!), so it can be ln also
 			//log (an / a1) / log (r) = n - 1
 			//log (an / a1) / log (r) + 1 = n
			fterm = rawvalues;//first: a1
			dterm = rawvalues + 40;//ratio: r
			term = rawvalues + 20;//nterm: an
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;

 			push_parse_text (term);
 			push_parse_text (fterm);
 			push_quantum_pair (DIV_TAG, LN_TAG);//I chose ln b/c that's how the
			push_parse_text (dterm);//system displays it
 			push_quantum_pair (LN_TAG, DIV_TAG);
 			push_longint ((long)1);
 			push_quantum (ADD_TAG);

 			ptr = top_estack;
 			NG_rationalESI (ptr);
 			exact = top_estack;
 			NG_approxESI (ptr);
 			approx = top_estack;

 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

 			ngetchx();
 			WinClr (DeskTop);

 			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
 			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

 			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
	}
	if (dialoghandle)
	{
		HeapFree (dialoghandle);
		dialoghandle = 0;
	}
	if (popuphandle)
	{
		HeapFree (popuphandle);
		popuphandle = 0;
	}
}
